/***************************  Suche.java  *************************************/
import AlgoTools.IO;

/**  lineare Suche eines Wertes und des Minimums im Array
 *   und binaere Suche im geordneten Array 
 */

public class Suche {

  public static void main (String argv[]) {

    int[] a;                                         // Feld fuer Zahlenfolge
    int i, x, min, index, links, rechts, mitte;

    a = IO.readInts("Bitte Zahlenfolge:      ");
    x = IO.readInt ("Bitte zu suchende Zahl: ");
                                                     // lineare Suche n. Element
    for (i=0; (i < a.length) && (x != a[i]); i++);   // durchlaufe Folge
    if (i==a.length) IO.println("Nicht gefunden");   // gib Suchergebnis bekannt
    else             IO.println("Gefunden an Position " + i);
                                                     // lineare Suche n. Minimum
    min = a[0]; index = 0;                           // Minimum ist erster Wert
    for (i = 1; i < a.length; i++){                  // durchlaufe gesamte Folge
        if (a[i] < min) {                            // falls neues Minimum 
            index = i;                               // merke Position 
            min   = a[i];}                           // und Wert des Minimums
    } IO.println("Minimum = " + min + " an Position " + index);
 
    a = IO.readInts("Bitte sortierte Zahlenfolge: ");// binaere Suche n. Element
    x = IO.readInt ("Bitte zu suchende Zahl:      ");// in sortierter Folge
    mitte = links = 0;                               // initialisiere links
    rechts = a.length-1;                             // initialisiere rechts
    while (links <= rechts) {                        // solange nichtleeres Int.
        mitte = (links + rechts) / 2;                // berechne Mitte
        if (a[mitte] == x) break;                    // richtig gesprungen
        if (a[mitte] < x)  links  = mitte+1;         // zu kurz gesprungen
        else               rechts = mitte-1;         // zu weit gesprungen
    }    
    if (links > rechts) IO.println("Nicht gefunden");
    else IO.println("Gefunden an Position " + mitte);
  }
}
